export declare class SqlBackup {
    private readonly backup;
    get idle(): boolean;
    get completed(): boolean;
    get failed(): boolean;
    /**
     * Returns an integer with the remaining number of pages left to copy
     * Returns -1 if `step` not yet called
     *
     */
    get remaining(): number;
    /**
     * Returns an integer with the total number of pages
     * Returns -1 if `step` not yet called
     *
     */
    get pageCount(): number;
    /**
     * Returns the progress (percentage completion)
     *
     */
    get progress(): number;
    /**
     * Creates an instance of SqlBackup.
     *
     * @param backup
     */
    constructor(backup: any);
    step(pages?: number): Promise<void>;
    finish(): void;
}
