import { ValueTransformer } from './ValueTransformer';
export declare class JsonTransformer implements ValueTransformer {
    toDB(input: any): string | null;
    fromDB(input: string | null): any;
}
export declare class BooleanTextTransformer implements ValueTransformer {
    toDB(input: boolean | undefined): string | null;
    fromDB(input: string | null): boolean | undefined;
}
export declare class BooleanNumberTransformer implements ValueTransformer {
    toDB(input: boolean | undefined): number | null;
    fromDB(input: number | null): boolean | undefined;
}
export declare class DateTextTransformer implements ValueTransformer {
    toDB(input: Date | undefined): string | null;
    fromDB(input: string | null): Date | undefined;
}
export declare class DateIntegerAsSecondsTransformer implements ValueTransformer {
    toDB(input: Date | undefined): number | null;
    fromDB(input: number | null): Date | undefined;
}
export declare class DateIntegerAsMillisecondsTransformer implements ValueTransformer {
    toDB(input: Date | undefined): number | null;
    fromDB(input: number | null): Date | undefined;
}
export declare class NumberTextTransformer implements ValueTransformer {
    toDB(input: number | undefined): string | null;
    fromDB(input: string | null): number | undefined;
}
export declare class NumberDefaultTransformer implements ValueTransformer {
    toDB(input: number | undefined): number | null;
    fromDB(input: number | null): number | undefined;
}
export declare class StringDefaultTransformer implements ValueTransformer {
    toDB(input: string | undefined): string | null;
    fromDB(input: string | null): string | undefined;
}
export declare class StringNumberTransformer implements ValueTransformer {
    toDB(input: string | undefined): number | null;
    fromDB(input: number | null): string | undefined;
}
export declare class UnknownDefaultTransformer implements ValueTransformer {
    toDB(input: any | undefined): string | null;
    fromDB(input: string | null): string | undefined;
}
export declare class DefaultValueTransformers {
    readonly json: ValueTransformer;
    readonly booleanText: ValueTransformer;
    readonly booleanNumber: ValueTransformer;
    readonly dateText: ValueTransformer;
    readonly dateIntegerAsSeconds: ValueTransformer;
    readonly dateIntegerAsMilliseconds: ValueTransformer;
    readonly numberText: ValueTransformer;
    readonly numberDefault: ValueTransformer;
    readonly stringNumber: ValueTransformer;
    readonly stringDefault: ValueTransformer;
    readonly unknownDefault: ValueTransformer;
}
export declare const DEFAULT_VALUE_TRANSFORMERS: DefaultValueTransformers;
