"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wait = void 0;
function wait(cond, timeout = 0, intervall = 100) {
    return new Promise((resolve, reject) => {
        let counter = 0;
        const timer = setInterval(() => {
            if (cond()) {
                clearInterval(timer);
                resolve();
                return;
            }
            if (timeout > 0 && ++counter * intervall >= timeout) {
                clearInterval(timer);
                reject(new Error('timeout reached'));
                return;
            }
        }, intervall);
    });
}
exports.wait = wait;
//# sourceMappingURL=wait.js.map